﻿B4i=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=2.5
@EndOfDesignText@
#DesignerProperty: Key: DecimalButton, DisplayName: Show Decimal, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: Hint, DisplayName: Hint, FieldType: String, DefaultValue: Enter a number
#DesignerProperty: Key: AnimationDuration, DisplayName: Animation Duration, FieldType: Int, DefaultValue: 300
#DesignerProperty: Key: BackgroundColor, DisplayName: Background Color, FieldType: Color, DefaultValue: #FFFFFFFF
Sub Class_Globals
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private mBase As Panel
	Private slidingPanel As Panel
	Private const spHeight = 255dip, spWidth = 170dip As Int
	Private side As Int
	Private const SIDE_UP = 1, SIDE_DOWN = 2, SIDE_LEFT = 3, SIDE_RIGHT = 4 As Int
	Private top, left As Int
	Private mProps As Map
	Private btnDecimal As Button
	Private flEditText1 As FloatLabeledTextField
	Private dummyPanel As Panel
	Private RootPanel As Panel
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase = Base
    slidingPanel.Initialize("")
	slidingPanel.Visible = False
	
	RootPanel = Props.Get("page")
	Dim Parent As Panel = mBase.Parent
	CalcSize
	Parent.AddView(slidingPanel, left, top, spWidth, spHeight)
	mProps = Props
	mBase.Tag = Me
	CallSubDelayed(Me, "LoadPanelLayout")
End Sub


Private Sub Base_Resize (Width As Double, Height As Double)
	flEditText1.SetLayoutAnimated(0, 1, 0, 0, Width, Height)
	dummyPanel.SetLayoutAnimated(0, 1, 0,0, Width, Height)
	CalcSize
	slidingPanel.SetLayoutAnimated(0,1, left, top, spWidth, spHeight)
End Sub

Private Sub CalcSize 
	left = Min(mBase.Left + mBase.Width / 2 - 95dip, RootPanel.Width - spWidth)
	If RootPanel.Height - mBase.Top - mBase.Height - spHeight > 0 Then
		'below
		side = SIDE_DOWN
		top = mBase.Top + mBase.Height + 2
	Else If mBase.Top > spHeight Then
		'above
		side = SIDE_UP
		top = mBase.Top - spHeight
	Else If mBase.Left + mBase.Width + spWidth < RootPanel.Width Then
		'right
		side = SIDE_RIGHT
		top = RootPanel.Height - spHeight
		left = mBase.Left + mBase.Width
	Else
		'left
		side = SIDE_LEFT
		top = RootPanel.Height - spHeight
		left = mBase.Left - spWidth
	End If
	
End Sub

Private Sub LoadPanelLayout
	slidingPanel.LoadLayout("Numpad")
	slidingPanel.Color = mProps.Get("BackgroundColor")
	btnDecimal.Visible = mProps.Get("DecimalButton")
	flEditText1.RemoveViewFromParent
	flEditText1.HintText = mProps.Get("Hint")
	mBase.AddView(flEditText1, 0, 0, mBase.Width, mBase.Height)
	dummyPanel.Initialize("dummy")
	dummyPanel.Color = Colors.Transparent
	mBase.AddView(dummyPanel, 0, 0, mBase.Width, mBase.Height)
	mBase.Tag = Me
	slidingPanel.SetShadow(Colors.Black, 3, 3, 0.8,False)
End Sub

Private Sub Dummy_Click
	Show
End Sub

Public Sub Show
	'hide other numpads
	For Each v As View In RootPanel.GetAllViewsRecursive
		If v.Tag <> Null And v.Tag Is Numpad And v.Tag <> Me Then
			Dim n As Numpad = v.Tag
			n.Hide
		End If
	Next
	If slidingPanel.Visible Then Return
	If side = SIDE_UP Then
		slidingPanel.SetLayoutAnimated(0,1, left, top + spHeight, spWidth, 0)
	else if side = SIDE_DOWN Then
		slidingPanel.SetLayoutAnimated(0,1,left, top, spWidth, 0)
	Else If side = SIDE_LEFT Then
		slidingPanel.SetLayoutAnimated(0,1,mBase.Left, top, 0, spHeight)
	Else If side = SIDE_RIGHT Then
		slidingPanel.SetLayoutAnimated(0,1,mBase.Left + mBase.Width, top, 0, spHeight)
	End If
	
	slidingPanel.Visible = True
	slidingPanel.SetLayoutAnimated(mProps.Get("AnimationDuration"),0.8, left, top, spWidth, spHeight)
	flEditText1.SetBorder(3dip, 0xFF545454, 2dip)
End Sub

Public Sub Hide
	slidingPanel.Visible = False
	flEditText1.SetBorder(2dip, Colors.Transparent, 2dip)
End Sub


Public Sub GetBase As Panel
	Return mBase
End Sub

Private Sub btnV_Click
	Hide
End Sub

Private Sub btnX_Click
	flEditText1.Text = ""
End Sub

Private Sub numpadButton_Click
	Dim b As Button = Sender
	If b.Text = "." And flEditText1.Text.Contains(".") Then Return
	flEditText1.Text = flEditText1.Text & b.Text
End Sub

Private Sub btnDel_Click
	If flEditText1.Text.Length > 0 Then
		flEditText1.Text = flEditText1.Text.SubString2(0, flEditText1.Text.Length - 1)
	End If
End Sub

Private Sub btnDel_LongClick
	flEditText1.Text = ""
End Sub

Public Sub getText As String
	Return flEditText1.Text
End Sub
Public Sub setText(s As String)
	If flEditText1.IsInitialized = False Then
		CallSubDelayed2(Me, "setText", s)
		Return
	End If
	flEditText1.Text = s
End Sub


